#!/usr/bin/perl


use ucp;
use IO::File;

my ($CONFIG) = "./smsc.cfg";
my $ADDR;
my $PORT;
my $PWD;
my $ID;



sub read_conf {
	my ($SET_ADDR) = 0;
	my ($SET_PORT) = 0;
	my ($SET_ID) = 0;
	my ($SET_PWD) = 0;

	$FILE = "< " . $CONFIG;
	open FILE or die "$CONFIG: $!\n";
	$error = 0;
	$line = <FILE>;


	while ($error == 0) {
		if (!($SET_PORT) && ($line =~ /^#Default Port/) ) {
			$SET_PORT = 1;
			$line = <FILE>;
			$line =~ /^(\d{4}|\d{5})$/;
			if (!defined($1)) {
				$error = -1;
			}
			else {
				$PORT = $1;
			}
		}
		if (!($SET_ADDR) && ($line =~ /^#Address:/) ) {
			$SET_ADDR = 1;
			$line = <FILE>;
			$line =~ /^(\d+\.\d+\.\d+\.\d+)$/;
			if (!defined($1)) {
				$error = -2;
			}
			else {
				$ADDR = $1;
			}
		}
		if (!($SET_PWD) && ($line =~ /^#Password/) ) {
			$SET_PWD = 1;
			$line = <FILE>;
			$line =~ /^(.*)/;
			if (!defined($1)) {
				$error = -3;
			}
			else {
				$PWD = $1;
			}
		}
		if (!($SET_ID) && ($line =~ /^#System ID/) ) {
			$SET_ID = 1;
			$line = <FILE>;
			$line =~ /^(.*)/;
			if (!defined($1)) {
				$error = -4;
			}
			else {
				$ID = $1;
			}
		}
		else {
			if (!eof(FILE)) {
				$line = <FILE>;
			}
			else {
				$error = -5;
			}
		}
		if (($error == 0) && ($SET_ADDR) && ($SET_PORT)  && ($SET_ID) && ($SET_PWD) ) {
			$error = 1;
		}
	}
	return (($error == 1) ? 0: -1);
}

if (scalar(@ARGV) != 3) {
	printf("Usage: prg ston.snpi.saddr dton.dnpi.daddr \"text\"\n");
	exit;
}

($ston, $snpi, $saddr) = ($ARGV[0] =~ /^(\d{1})\.(\d{1})\.(.*)/);
if (!defined($ston) || !defined($snpi) || !defined($saddr)) {
	printf("Usage: prg ston.snpi.saddr dton.dnpi.daddr \"text\"\n");
	exit;
}
	
($dton, $dnpi, $daddr) = ($ARGV[1] =~ /^(\d{1})\.(\d{1})\.(.*)/);
if (!defined($dton) || !defined($dnpi) || !defined($daddr)) {
	printf("Usage: prg ston.snpi.saddr dton.dnpi.daddr \"text\"\n");
	exit;
}
$text = $ARGV[2];
if (!defined($text)) {
	printf("Usage: prg ston.snpi.saddr dton.dnpi.daddr \"text\"\n");
	exit;
}

if ((read_conf) == 0) {
	$sm = new ucp;
	if ($sm->connect($ADDR, $PORT) == 0) {
		if ($sm->open_session("5000", $ston, $snpi, $PWD, "PC") != 0) {
			printf("open session error.\n");
			$sm->print_resp;
			exit;
			$Any_Error = 3;
		}
		else {
#		$sm->print_resp;
			if ($sm->submit(0, "", "", 0, $saddr , $daddr, 0, $text) == 0) {
#			printf("oke\n");
				;
			}
			else {
				printf("submit error.\n");
				$sm->print_resp;
			}
		}
	}
}
else {
	printf("Unknown config file format...\n");
}


